package abc.ar.ast;

import java.util.List;

import polyglot.ast.Block;
import polyglot.ast.Call;
import polyglot.ast.Expr;
import polyglot.ast.Receiver;
import polyglot.ast.TypeNode;
import polyglot.lex.Identifier;
import polyglot.types.Flags;
import polyglot.util.Position;
import abc.aspectj.ast.AJNodeFactory;
import abc.aspectj.ast.AdviceDecl;
import abc.aspectj.ast.AdviceFormal;
import abc.aspectj.ast.AdviceSpec;
import abc.aspectj.ast.After;
import abc.aspectj.ast.AfterReturning;
import abc.aspectj.ast.AfterThrowing;
import abc.aspectj.ast.Around;
import abc.aspectj.ast.AspectBody;
import abc.aspectj.ast.PerClause;
import abc.aspectj.ast.Pointcut;
import abc.aspectj.extension.AJCall_c;

public interface ARNodeFactory extends AJNodeFactory {
	AspectRefinementDecl AspectRefinementDecl(Position pos, boolean is_privileged, Flags flags, String name,
			List interfaces, PerClause per, AspectBody body, String featureName);

	Pointcut PCSuperName(Position pos, Receiver target, String name, List args);

	NamedAdviceDecl NamedAdviceDecl(Position pos, Flags flags, AdviceSpec spec, List throwTypes,
			Pointcut pc, Block /*optional*/ body);
	
	NamedBefore NamedBefore(Position pos, String name, List formals, TypeNode voidn);
	After NamedAfter(Position pos, String name, List formals, TypeNode voidn);
	Around NamedAround(Position pos, String name, TypeNode returnType, List formals);
	AfterThrowing NamedAfterThrowing(Position pos, String name, List formals, AdviceFormal exc, TypeNode voidn);
	AfterReturning NamedAfterReturning(Position pos, String name, List formals, AdviceFormal returnResult, TypeNode voidn);

}
