package abc.ar.ast;

import java.util.List;

import polyglot.ast.Block;
import polyglot.ast.Call;
import polyglot.ast.Receiver;
import polyglot.ast.TypeNode;
import polyglot.types.Flags;
import polyglot.util.Position;
import abc.aspectj.ast.AJNodeFactory_c;
import abc.aspectj.ast.AdviceFormal;
import abc.aspectj.ast.AdviceSpec;
import abc.aspectj.ast.After;
import abc.aspectj.ast.AfterReturning;
import abc.aspectj.ast.AfterThrowing;
import abc.aspectj.ast.Around;
import abc.aspectj.ast.AspectBody;
import abc.aspectj.ast.AspectDecl;
import abc.aspectj.ast.Before;
import abc.aspectj.ast.Before_c;
import abc.aspectj.ast.PCName;
import abc.aspectj.ast.PCName_c;
import abc.aspectj.ast.PerClause;
import abc.aspectj.ast.Pointcut;
import abc.aspectj.extension.AJCall_c;

public class ARNodeFactory_c extends AJNodeFactory_c implements ARNodeFactory {

	public AspectRefinementDecl AspectRefinementDecl(Position pos, boolean is_privileged, Flags flags, String name,
			List interfaces, PerClause per, AspectBody body, String featureName) {
		return new AspectRefinementDecl_c(pos, is_privileged, flags, name, interfaces, per, body, featureName);
	}

	public AspectDecl AspectDecl(Position pos, boolean is_privileged, Flags flags, String name, TypeNode superClass,
			List interfaces, PerClause per, AspectBody body) {
		return new RefinableAspectDecl_c(pos, is_privileged, flags, name, superClass, interfaces, per, body);
	}

	public Pointcut PCSuperName(Position pos, Receiver target, String name, List args) {
		return new PCSuperName_c(pos, target, name, args);
	}

	public NamedAdviceDecl NamedAdviceDecl(Position pos, Flags flags, AdviceSpec spec, List throwTypes, Pointcut pc, /*optional*/Block body) {
		return new NamedAdviceDecl_c(pos, flags, spec, throwTypes, pc, body);
	}

	public NamedBefore NamedBefore(Position pos, String name, List formals, TypeNode voidn) {
		return new NamedBefore_c(pos, name, formals, voidn);
	}

	public After NamedAfter(Position pos, String name, List formals, TypeNode voidn) {
		return new NamedAfter_c(pos, name, formals, voidn);
	}

	public Around NamedAround(Position pos, String name, TypeNode returnType, List formals) {
		return new NamedAround_c(pos, name, returnType, formals);
	}

	public AfterThrowing NamedAfterThrowing(Position pos, String name, List formals, AdviceFormal exc, TypeNode voidn) {
		return new NamedAfterThrowing_c(pos, name, formals, exc,voidn);
	}

	public AfterReturning NamedAfterReturning(Position pos, String name, List formals, AdviceFormal returnResult, TypeNode voidn) {
		return new NamedAfterReturning_c(pos, name, formals, returnResult, voidn);
	}

    public Call Call(Position pos, Receiver target, String name, List arguments) {
		Call n = new ARCall_c(pos, target, name, arguments);
		n = (Call) n.ext(extFactory.extAJCall());
		n = (Call) n.del(delFactory.delAJCall());
		return n;
	}
}
