package abc.ar.ast;

import java.util.List;

import polyglot.ast.TypeNode;
import polyglot.types.Flags;
import polyglot.util.Position;
import abc.aspectj.ast.AspectBody;
import abc.aspectj.ast.AspectDecl_c;
import abc.aspectj.ast.PerClause;

public class RefinableAspectDecl_c extends AspectDecl_c implements RefinableAspectDecl {

	private final String _originalName;

	public RefinableAspectDecl_c(Position pos, boolean is_privileged, Flags flags, String name, TypeNode superClass, List interfaces, PerClause per, AspectBody body) {
		super(pos, is_privileged, flags, name, superClass, interfaces, per, body);
		_originalName = name;
	}

	private boolean isRefined=false;
	private String featureName="undefined";

	public void setRefined(boolean isRefined) {
		this.isRefined = isRefined;
	}

	public boolean isRefined() {
		return isRefined;
	}
	
	public String toString() {
		return (isRefined()?"refinded ":"not_refined")+" "+super.toString()+" (feature: "+featureName+")";
	}

	public void setFeatureName(String featureName) {
		this.featureName = featureName;
	}

	public String getFeatureName() {
		return featureName;
	}

	public String getOriginalName() {
		return _originalName;
	}
}
