package abc.ar.visit;

import java.util.Stack;

import polyglot.ast.MethodDecl;
import polyglot.ast.NodeFactory;
import polyglot.frontend.Job;
import polyglot.types.TypeSystem;
import abc.ar.ast.NamedAdviceDecl;
import abc.aspectj.visit.AspectMethods;


/**
 * extention to the AspectMethods visitor which supports the named
 * methods of NamedAround.
 * 
 * @author cKaestner
 *
 */
public class NamedAspectMethods extends AspectMethods {

    private Stack /* MethodDecl */ namedArounds; // dummy proceed methods for transforming namedArounds calls
	
	
	public NamedAspectMethods(Job job, NodeFactory nf, TypeSystem ts) {
		super(job, nf, ts);
		namedArounds=new Stack();
	}

	   public void pushNamedAroundFor(NamedAdviceDecl ad)
       {
		   namedArounds.push(ad.namedAroundDecl(nf,ts));
       }

       public MethodDecl namedAround()
       {
               return (MethodDecl) namedArounds.peek();
       }

       public void popNamedAround()
       {
    	   namedArounds.pop();
       }
	
}
