package abc.ar.visit;

import polyglot.frontend.Job;
import polyglot.types.SemanticException;
import polyglot.util.ErrorInfo;
import abc.ar.AbcExtension;
import abc.aspectj.visit.OncePass;

/**
 * simple once pass that calls the build hierachie function of the RefinementManager
 * 
 * 
 * @author Christian Kaestner and Sven Apel
 */
public class RefinementHierachieBuilder extends OncePass {
	protected Job job;

	public RefinementHierachieBuilder(ID id, Job job) {
		super(id);
		this.job = job;
	}

	protected void once() {
		try {
			AbcExtension.v().getRefinementManager().buildHierachie();
		} catch (SemanticException e) {
			job.compiler().errorQueue().enqueue(
					ErrorInfo.SEMANTIC_ERROR,e.getLocalizedMessage());
		}
	}

}
