package abc.ar.weaving.weaver.around;

import java.util.List;

import soot.SootClass;
import soot.SootMethod;
import abc.weaving.weaver.around.AdviceLocalClass;
import abc.weaving.weaver.around.AdviceMethod;
import abc.weaving.weaver.around.AroundWeaver;
import abc.weaving.weaver.around.ProceedMethod;

public class ARAdviceMethod extends AdviceMethod {

	private String adviceName;

	ARAdviceMethod(AroundWeaver aroundWeaver, SootMethod method, List originalAdviceFormalTypes,
			List proceedSootMethods, String adviceName) {
		super(aroundWeaver, method, originalAdviceFormalTypes, proceedSootMethods);
		this.adviceName = adviceName;
	}

	protected AdviceLocalClass newAdviceLocalClass(AdviceMethod method, SootClass enclosing) {
		return new ARAdviceLocalClass(method, enclosing, adviceName);
	}

	protected ProceedMethod newProceedMethod(AdviceMethod method, SootClass declaringClass,
			boolean useStaticProceedMethod, String proceedMethodName, boolean useClosureObject) {
		return new ARProceedMethod(method, declaringClass, useStaticProceedMethod, proceedMethodName, useClosureObject);
	}
}
